pcl::FPFHEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

FPFHEstimation estimates the Fast Point Feature Histogram (FPFH) descriptor for a given point cloud dataset containing points and normals. More...

`#include <pcl/features/fpfh.h>`

Inheritance diagram for pcl::FPFHEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< FPFHEstimation< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const FPFHEstimation< PointInT, PointNT, PointOutT > >
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| FPFHEstimation ()
| Empty constructor. More...
bool | computePairFeatures (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, int p_idx, int q_idx, float &f1, float &f2, float &f3, float &f4)
| Compute the 4-tuple representation containing the three angles and one distance between two points represented by Cartesian coordinates and normals. More...
void | computePointSPFHSignature (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, pcl::index_t p_idx, int row, const pcl::Indices &indices, Eigen::MatrixXf &hist_f1, Eigen::MatrixXf &hist_f2, Eigen::MatrixXf &hist_f3)
| Estimate the SPFH (Simple Point Feature Histograms) individual signatures of the three angular (f1, f2, f3) features for a given point based on its spatial neighborhood of 3D points with normals. More...
void | weightPointSPFHSignature (const Eigen::MatrixXf &hist_f1, const Eigen::MatrixXf &hist_f2, const Eigen::MatrixXf &hist_f3, const pcl::Indices &indices, const std::vector< float > &dists, Eigen::VectorXf &fpfh_histogram)
| Weight the SPFH (Simple Point Feature Histograms) individual histograms to create the final FPFH (Fast Point Feature Histogram) for a given point based on its 3D spatial neighborhood. More...
void | setNrSubdivisions (int nr_bins_f1, int nr_bins_f2, int nr_bins_f3)
| Set the number of subdivisions for each angular feature interval. More...
void | getNrSubdivisions (int &nr_bins_f1, int &nr_bins_f2, int &nr_bins_f3)
| Get the number of subdivisions for each angular feature interval. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeSPFHSignatures (std::vector< int > &spf_hist_lookup, Eigen::MatrixXf &hist_f1, Eigen::MatrixXf &hist_f2, Eigen::MatrixXf &hist_f3)
| Estimate the set of all SPFH (Simple Point Feature Histograms) signatures for the input cloud. More...
void | computeFeature (PointCloudOut &output) override
| Estimate the Fast Point Feature Histograms (FPFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

int | nr_bins_f1_
| The number of subdivisions for each angular feature interval. More...
int | nr_bins_f2_
int | nr_bins_f3_
Eigen::MatrixXf | hist_f1_
| Placeholder for the f1 histogram. More...
Eigen::MatrixXf | hist_f2_
| Placeholder for the f2 histogram. More...
Eigen::MatrixXf | hist_f3_
| Placeholder for the f3 histogram. More...
Eigen::VectorXf | fpfh_histogram_
| Placeholder for a point's FPFH signature. More...
float | d_pi_
| Float constant = 1.0 / (2.0 * M_PI) More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::FPFHSignature33 >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT = pcl::FPFHSignature33>
class pcl::FPFHEstimation< PointInT, PointNT, PointOutT >

FPFHEstimation estimates the Fast Point Feature Histogram (FPFH) descriptor for a given point cloud dataset containing points and normals.

A commonly used type for PointOutT is pcl::FPFHSignature33.

Note
  If you use this code in any academic work, please cite:

- R.B. Rusu, N. Blodow, M. Beetz. Fast Point Feature Histograms (FPFH) for 3D Registration. In Proceedings of the IEEE International Conference on Robotics and Automation (ICRA), Kobe, Japan, May 12-17 2009.
- R.B. Rusu, A. Holzbach, N. Blodow, M. Beetz. Fast Geometric Point Labeling using Conditional Random Fields. In Proceedings of the 22nd IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS), St. Louis, MO, USA, October 11-15 2009.

Attention
  The convention for FPFH features is:
  - if a query point's nearest neighbors cannot be estimated, the FPFH feature will be set to NaN (not a number)
  - it is impossible to estimate a FPFH descriptor for a point that doesn't have finite 3D coordinates. Therefore, any point that contains NaN data on x, y, or z, will have its FPFH feature property set to NaN.

Note
  The code is stateful as we do not expect this class to be multicore parallelized. Please look at FPFHEstimationOMP for examples on parallel implementations of the FPFH (Fast Point Feature Histogram).

Author
  Radu B. Rusu

Definition at line 78 of file fpfh.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

using pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::ConstPtr = shared_ptr<const FPFHEstimation<PointInT, PointNT, PointOutT> >

Definition at line 82 of file fpfh.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

using pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 92 of file fpfh.h.

## Ptr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

using pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::Ptr = shared_ptr<FPFHEstimation<PointInT, PointNT, PointOutT> >

Definition at line 81 of file fpfh.h.

## Constructor & Destructor Documentation

## FPFHEstimation()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::FPFHEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 95 of file fpfh.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate the Fast Point Feature Histograms (FPFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset that contains the FPFH feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 238 of file fpfh.hpp.

References pcl::PointCloud< PointT >::is_dense, and pcl::isFinite().

## computePairFeatures()

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computePairFeatures | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | int | p_idx,
|  | int | q_idx,
|  | float & | f1,
|  | float & | f2,
|  | float & | f3,
|  | float & | f4
| ) |  |

Compute the 4-tuple representation containing the three angles and one distance between two points represented by Cartesian coordinates and normals.

Note
  For explanations about the features, please see the literature mentioned above (the order of the features might be different).

Parameters

  [in] | cloud | the dataset containing the XYZ Cartesian coordinates of the two points
  [in] | normals | the dataset containing the surface normals (assuming normalized vectors) at each point in cloud
  [in] | p_idx | the index of the first point (source)
  [in] | q_idx | the index of the second point (target)
  [out] | f1 | the first angular feature (angle between the projection of nq_idx and u)
  [out] | f2 | the second angular feature (angle between nq_idx and v)
  [out] | f3 | the third angular feature (angle between np_idx and |p_idx - q_idx|)
  [out] | f4 | the distance feature (p_idx - q_idx)

Definition at line 52 of file fpfh.hpp.

References pcl::computePairFeatures().

## computePointSPFHSignature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computePointSPFHSignature | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | pcl::index_t | p_idx,
|  | int | row,
|  | const pcl::Indices & | indices,
|  | Eigen::MatrixXf & | hist_f1,
|  | Eigen::MatrixXf & | hist_f2,
|  | Eigen::MatrixXf & | hist_f3
| ) |  |

Estimate the SPFH (Simple Point Feature Histograms) individual signatures of the three angular (f1, f2, f3) features for a given point based on its spatial neighborhood of 3D points with normals.

Parameters

  [in] | cloud | the dataset containing the XYZ Cartesian coordinates of the two points
  [in] | normals | the dataset containing the surface normals at each point in cloud
  [in] | p_idx | the index of the query point (source)
  [in] | row | the index row in feature histogramms
  [in] | indices | the k-neighborhood point indices in the dataset
  [out] | hist_f1 | the resultant SPFH histogram for feature f1
  [out] | hist_f2 | the resultant SPFH histogram for feature f2
  [out] | hist_f3 | the resultant SPFH histogram for feature f3

Definition at line 64 of file fpfh.hpp.

References pcl::computePairFeatures(), and M_PI.

## computeSPFHSignatures()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computeSPFHSignatures | ( | std::vector< int > & | spf_hist_lookup,
|  | Eigen::MatrixXf & | hist_f1,
|  | Eigen::MatrixXf & | hist_f2,
|  | Eigen::MatrixXf & | hist_f3
| ) |  |

protected

Estimate the set of all SPFH (Simple Point Feature Histograms) signatures for the input cloud.

Parameters

  [out] | spf_hist_lookup | a lookup table for all the SPF feature indices
  [out] | hist_f1 | the resultant SPFH histogram for feature f1
  [out] | hist_f2 | the resultant SPFH histogram for feature f2
  [out] | hist_f3 | the resultant SPFH histogram for feature f3

Definition at line 182 of file fpfh.hpp.

## getNrSubdivisions()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::getNrSubdivisions | ( | int & | nr_bins_f1,
|  | int & | nr_bins_f2,
|  | int & | nr_bins_f3
| ) |  |

inline

Get the number of subdivisions for each angular feature interval.

Parameters

  [out] | nr_bins_f1 | number of subdivisions for the first angular feature
  [out] | nr_bins_f2 | number of subdivisions for the second angular feature
  [out] | nr_bins_f3 | number of subdivisions for the third angular feature

Definition at line 172 of file fpfh.h.

References pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f1_, pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f2_, and pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f3_.

## setNrSubdivisions()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions | ( | int | nr_bins_f1,
|  | int | nr_bins_f2,
|  | int | nr_bins_f3
| ) |  |

inline

Set the number of subdivisions for each angular feature interval.

Parameters

  [in] | nr_bins_f1 | number of subdivisions for the first angular feature
  [in] | nr_bins_f2 | number of subdivisions for the second angular feature
  [in] | nr_bins_f3 | number of subdivisions for the third angular feature

Definition at line 159 of file fpfh.h.

References pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f1_, pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f2_, and pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f3_.

## weightPointSPFHSignature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::weightPointSPFHSignature | ( | const Eigen::MatrixXf & | hist_f1,
|  | const Eigen::MatrixXf & | hist_f2,
|  | const Eigen::MatrixXf & | hist_f3,
|  | const pcl::Indices & | indices,
|  | const std::vector< float > & | dists,
|  | Eigen::VectorXf & | fpfh_histogram
| ) |  |

Weight the SPFH (Simple Point Feature Histograms) individual histograms to create the final FPFH (Fast Point Feature Histogram) for a given point based on its 3D spatial neighborhood.

Parameters

  [in] | hist_f1 | the histogram feature vector of f1 values over the given patch
  [in] | hist_f2 | the histogram feature vector of f2 values over the given patch
  [in] | hist_f3 | the histogram feature vector of f3 values over the given patch
  [in] | indices | the point indices of p_idx's k-neighborhood in the point cloud
  [in] | dists | the distances from p_idx to all its k-neighbors
  [out] | fpfh_histogram | the resultant FPFH histogram representing the feature at the query point

Definition at line 110 of file fpfh.hpp.

## Member Data Documentation

## d_pi_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

float pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::d_pi_

protected

Float constant = 1.0 / (2.0 * M_PI)

Definition at line 215 of file fpfh.h.

## fpfh_histogram_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

Eigen::VectorXf pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::fpfh_histogram_

protected

Placeholder for a point's FPFH signature.

Definition at line 212 of file fpfh.h.

## hist_f1_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

Eigen::MatrixXf pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::hist_f1_

protected

Placeholder for the f1 histogram.

Definition at line 203 of file fpfh.h.

## hist_f2_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

Eigen::MatrixXf pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::hist_f2_

protected

Placeholder for the f2 histogram.

Definition at line 206 of file fpfh.h.

## hist_f3_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

Eigen::MatrixXf pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::hist_f3_

protected

Placeholder for the f3 histogram.

Definition at line 209 of file fpfh.h.

## nr_bins_f1_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

int pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f1_

protected

The number of subdivisions for each angular feature interval.

Definition at line 200 of file fpfh.h.

Referenced by pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::getNrSubdivisions(), and pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions().

## nr_bins_f2_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

int pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f2_

protected

Definition at line 200 of file fpfh.h.

Referenced by pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::getNrSubdivisions(), and pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions().

## nr_bins_f3_

template<typename PointInT , typename PointNT , typename PointOutT = pcl::FPFHSignature33>

int pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::nr_bins_f3_

protected

Definition at line 200 of file fpfh.h.

Referenced by pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::getNrSubdivisions(), and pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions().

The documentation for this class was generated from the following files:

- pcl/features/fpfh.h
- pcl/features/impl/fpfh.hpp